clear all;
close all;

xlsFileName='Data OECD on output gap and primary balances.xlsx';
[val,textdata] = xlsread(xlsFileName,'NLGXQA');
nms=textdata(4,2:end);
assert( size(val,2) == size(nms,2), 'mismatch number of columns and number of names');
for ci=1:size(val,2)
    eval( [ nms{ci}, ' = val(:,ci);' ] ); % name the column
end

[val2,textdata2] = xlsread(xlsFileName,'GAP');
nms=textdata2(4,2:end);
assert( size(val2,2) == size(nms,2), 'mismatch number of columns and number of names');
for ci=1:size(val2,2)
    eval( [ nms{ci}, ' = val2(:,ci);' ] ); % name the column
end

%Data goes from 1960 to 2015 
% Years 2006 and 2013 correspond to indexes 37 and 44 and 27 and 34
firstnl=37;
lastnl=44;
firstgap=27;
lastgap=34;
labels=['2006';'2007';'2008';'2009';'2010';'2011';'2012';'2013'];
countries={'IRL','ITA','ESP','PRT','FRA','GBR','DEU','USA','BEL','NLD','DNK','TOT','EA15'};
countrynames={'IRL','ITA','ESP','PRT','FRA','GBR','DEU','USA','BEL','NLD','DNK','Advanced Economies','Euro Area Economies'};

for i=1:size(countries,2)
    f=figure('Color',[1 1 1]);
    eval(['plot(',countries{i},'.GAP(firstgap:lastgap),diff(',countries{i},'.NLGXQA(firstnl-1:lastnl)));']);
    eval(['ti=text(',countries{i},'.GAP(firstgap:lastgap),diff(',countries{i},'.NLGXQA(firstnl-1:lastnl)),labels);']);
    hx = graph2d.constantline(0, 'LineStyle',':', 'Color',[.7 .7 .7]);
    changedependvar(hx,'x');
    %eval(['hy = graph2d.constantline(mean(',countries{i},'.NLGXQA(firstnl:lastnl)), ''LineStyle'','':'',''Color'',[.7 .7 .7]);']);
    hy = graph2d.constantline(0, 'LineStyle',':','Color',[.7 .7 .7]);
    changedependvar(hy,'y');
    eval(['t1=title(''',countrynames{i},''');']);
    x1=xlabel('Output gap');
    y1=ylabel('Changes in Cyclically-Adjusted Primary Balance');
    %set([xl,yl], 'FontName', 'AvantGarde','FontSize',14);
    set(x1, 'FontName', 'AvantGarde','FontSize',12);
    set(y1, 'FontName', 'AvantGarde','FontSize',12);
    set(t1, 'FontName', 'AvantGarde','FontSize',14);
    
    annotation(f,'textbox',...
    [0.136707236842105 0.195445920303605 0.0546990131578946 0.0919995409854896],...
    'String',{'Counter-cyclical','fiscal','expansion'},...
    'FontName','AvantGarde',...
    'FitBoxToText','off',...
    'EdgeColor','none');


    annotation(f,'textbox',...
    [0.752332236842107 0.867426690874219 0.157511513157895 0.0367170626349902],...
    'String',{'Counter-cyclical fiscal tightening'},...
    'FontName','AvantGarde',...
    'FitBoxToText','off',...
    'EdgeColor','none');


    annotation(f,'textbox',...
    [0.135457236842105 0.874143958426401 0.157511513157895 0.0367170626349902],...
    'String',{'Pro-cyclical fiscal tightening'},...
    'FontName','AvantGarde',...
    'FitBoxToText','off',...
    'EdgeColor','none');


    annotation(f,'textbox',...
    [0.744519736842106 0.138773939451069 0.157511513157895 0.0367170626349902],...
    'String',{'Pro-cyclical fiscal expansion'},...
    'FontName','AvantGarde',...
    'FitBoxToText','off',...
    'EdgeColor','none');
    %set(ti, 'FontName', 'AvantGarde','FontSize',8);
    %eval(['print(f,''-dbmp16m'',''Cycle',countries{i},'.bmp'')']);
end
